;==================================================================================================
;AUTHOR   : https://www.xyplorer.com/xyfc/viewtopic.php?t=25763
;Function : XYplorer custom queue menus
;Created  : 2023-03-10
;Modified : 2023-08-23
;Version  : v1.2.12QS
;==================================================================================================
#Requires AutoHotkey v2.0
#SingleInstance Ignore
#NoTrayIcon
Persistent


; Get our own HWND (we have no visible window)
G_OwnHWND := A_ScriptHwnd + 0


; Get messages back from XYplorer
OnMessage(0x4a, Receive_WM_COPYDATA)

; Get messages
OnMessage 0x004A, Receive_WM_COPYDATA2  ; 0x004A is WM_COPYDATA

dataReceived := "", CopyOfData:=""

xyPath  := "D:\XYplorer\XYplorer.exe"      ; XY path
/*
if !FileExist(xyPath)
{
   TrayTip xyPath, "XYplorer path does not exist!"
   return
}
*/

exHwnd  := ""
global selMenu:="", selPos:="", selItem:="", IDLast:=""






;==================================================================================================
; Dark theme
;==================================================================================================

; Dark mode (Required Windows 10 version)
uxtheme := DllCall("GetModuleHandle", "str", "uxtheme", "ptr")
SetPreferredAppMode := DllCall("GetProcAddress", "ptr", uxtheme, "ptr", 135, "ptr")
FlushMenuThemes := DllCall("GetProcAddress", "ptr", uxtheme, "ptr", 136, "ptr")
DllCall(SetPreferredAppMode, "int", 1) ; Dark
DllCall(FlushMenuThemes)

; Switch from dark to not dark
/*
DllCall(SetPreferredAppMode, "int", 0) ; NOT Dark
DllCall(FlushMenuThemes)
*/



;==================================================================================================
; Add menu items, the format is   Name|XY script|Icon file
;==================================================================================================

menuItems := '
    (
     11`tB|echo "11"|.\Icons\2.ico
	 22|echo "22"
	 33|echo "33"
	 44|echo "44"
	 55|echo "55"
	)'






;==================================================================================================
; Create a popup menu
;==================================================================================================

; Create main menu
 MyMenu := Menu()
 ;MyMenu.Name := "Main menu"                                   ; Used to show which menu is selected

 menuItemsArray := strSplit(menuItems, "`n")
 for index, menuItem in menuItemsArray
 {
    itemsArray := strSplit(trim(menuItem), "|")
    for index2, itemApart in itemsArray
    {
	   switch index2
	   {
	      case "1":
              if itemApart != "-"                                             ; Add an item to the menu, or add a separator
	             MyMenu.Add itemApart, MenuHandler
			  else
			     MyMenu.Add

          case "3":
              if FileExist(itemApart)
                 MyMenu.SetIcon(itemsArray[1], itemApart)                     ; Add icon if icon file exists
	   }
    }
 }

 MyMenu.Default := "11`tB"

; Global selected
MenuHandler(Item, ItemPos, MyMenu) {
    if WinExist("ahk_class #32768")                               ; Automatically close another menu
	   global IDLast := WinGetIDLast("ahk_class #32768")
    if WinExist("ahk_id " IDLast)
       WinClose

	;MsgBox "You selected " Item " (position " ItemPos " in " MyMenu.Name ")"
	;global selMenu:=MyMenu.Name, selPos:=ItemPos, selItem:=Item   ; Global varibles

    selItem := strSplit(trim(menuItemsArray[ItemPos]), "|")[2]
	global selItem   ; Global varible
}






;==================================================================================================
; Display custom menu
;==================================================================================================

popupMenu()
{

    while !WinExist("ahk_class #32768") {                         ; Wait for the first menu to display and then get the coordinates
	   sleep 1
	   if A_Index = 120
	      break
	}

    sleep 50
    try IDLast := WinGetIDLast("ahk_class #32768")
	catch {
	    sleep 5
		try IDLast := WinGetIDLast("ahk_class #32768")
		catch
		    return
	}

    WinGetPos &X, &Y, &W, &H, "ahk_id " IDLast
    CoordMode "Menu"
    MyMenu.Show(X+W, Y)                                           ; Display menu2 at

    MouseGetPos , , &id                                           ; Automatically close another menu
    if(WinGetClass("ahk_id " id) != "#32768")
	{
	   try {
	        IDLast := WinGetIDLast("ahk_class #32768")
	        if WinExist("ahk_id " IDLast)
               WinClose("ahk_id " IDLast)
	       }
	} else if !GetKeyState("LButton", "P")
	{
		  if !WinActivate("ahk_class #32768") && WinExist("ahk_class #32768")
		      WinClose("ahk_class #32768")
	}






;==================================================================================================
; Perform different actions
;==================================================================================================

 switch selItem
 {
    case "":                                                                             ; return if no menu item is selected
	    return
    default:                                                                             ; If a menu item is selected
        if xyHwnd := GetXYHWND() {                                                       ; If xy is running
		   WinActivate("ahk_id " xyHwnd)                                                 ; Active XY window
           Send_WM_COPYDATA(xyHwnd, '::' selItem)                                        ; Send the script to XY
        } else {
           Run xyPath ' /feed=|::' selItem '|'                                           ; Run the script via XYplorer.exe
           WinWaitActive WinExist("ahk_class ThunderRT6FormDC")                          ; Waiting to activate the window
           while !xyHwnd := GetXYHWND()
               sleep 1000
           WinActivate "ahk_id " xyHwnd
        }
 }

 global selMenu:="", selPos:="", selItem:=""
 return

}






;==================================================================================================
; XYplorer Send and Get functions
;==================================================================================================

XY_Get(bAll:=false, bSelection:=false)
{
    xyQueryScript := '::if (!' bAll ' && !' bSelection ') {$return = "<curpath>"`;} elseif (' bAll ') {$return = listpane(, , , "<crlf>")`;} elseif (' bSelection ') {$return = get("SelectedItemsPathNames", "<crlf>")`;} copydata ' G_OwnHWND ', "$return", 2`;'

    if xyHwnd := GetXYHWND()
       Send_WM_COPYDATA(xyHwnd, xyQueryScript)

    return dataReceived
}


GetXYHWND() {
	static xyClass := 'ahk_class ThunderRT6FormDC'

    if WinExist(xyClass) {
        for xyid in WinGetList(xyClass)
            for ctrl in WinGetControls(xyid)
                if A_Index = 10
                   return xyid
    }
}


Send_WM_COPYDATA(xyHwnd, message) {
   if !(xyHwnd)
       return

   size := StrLen(message)

   COPYDATA := Buffer(A_PtrSize * 3)
   NumPut("Ptr", 4194305, COPYDATA, 0)
   NumPut("UInt", size * 2, COPYDATA, A_PtrSize)
   NumPut("Ptr", StrPtr(message), COPYDATA, A_PtrSize * 2)

   return DllCall("User32.dll\SendMessageW", "Ptr", xyHwnd, "UInt", 74, "Ptr", 0, "Ptr", COPYDATA, "Ptr")
}


Receive_WM_COPYDATA(wParam, lParam, *) {
	global dataReceived := StrGet(
		NumGet(lParam + 2 * A_PtrSize, 'Ptr'),   ; COPYDATASTRUCT.lpData, ptr to a str presumably
		NumGet(lParam + A_PtrSize, 'UInt') / 2   ; COPYDATASTRUCT.cbData, count bytes of lpData, /2 to get count chars in unicode str
	)
}






;==================================================================================================
; Send message to display next menu
;==================================================================================================

Send_WM_COPYDATA2(StringToSend, TargetScriptTitle)
{
    CopyDataStruct := Buffer(3*A_PtrSize)  ; Set up the structure's memory area.
    SizeInBytes := (StrLen(StringToSend) + 1) * 2
    NumPut( "Ptr", SizeInBytes, "Ptr", StrPtr(StringToSend), CopyDataStruct, A_PtrSize)
    Prev_DetectHiddenWindows := A_DetectHiddenWindows
    Prev_TitleMatchMode := A_TitleMatchMode
    DetectHiddenWindows True
    SetTitleMatchMode 2
    TimeOutTime := 10  ; Optional. Milliseconds to wait for response from receiver.ahk. Default is 5000
    try RetValue := SendMessage(0x004A, 0, CopyDataStruct,, TargetScriptTitle,,,, TimeOutTime) ; 0x004A is WM_COPYDATA.
	catch
	    return
    DetectHiddenWindows Prev_DetectHiddenWindows  ; Restore original setting for the caller.
    SetTitleMatchMode Prev_TitleMatchMode         ; Same.
    return RetValue  ; Return SendMessage's reply back to our caller.
}


;==================================================================================================
; Receive message
;==================================================================================================

Receive_WM_COPYDATA2(wParam, lParam, msg, hwnd)
{
    StringAddress := NumGet(lParam, 2*A_PtrSize, "Ptr")  ; Retrieves the CopyDataStruct's lpData member.
    global CopyOfData := StrGet(StringAddress)  ; Copy the string out of the structure.
	if CopyOfData = "Ready"      ; Popup menu if receive messages
	   popupMenu()
	else if(CopyOfData = "Exit")
	   ExitApp
    return true
}